<?php
/**
 * Table Definition for community
 * @package wawawa
 * @author halt <halt@sonata.zive.net>
 * @version $Id: Community.php,v 1.2 2004/07/18 16:34:25 halt1983 Exp $
 */

require_once 'DB/DataObject.php';

/**
 * Community Class
 * @package wawawa
 * @author halt <halt@sonata.zive.net>
 */
class Community extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'community';                       // table name
    var $id;                              // int4(4)  not_null default_nextval%28public.community_id_seq%29 primary_key
    var $owner;                           // text(-1)  not_null
    var $createtime;                      // timestamp(8)  default_now%28%29
    var $name;                            // text(-1)  not_null
    var $category;                        // text(-1)  not_null
    var $explanation;                     // text(-1)  
    var $url;                             // text(-1)  not_null
    var $rss;                             // text(-1)  
    var $xmlrpc;                          // text(-1)  
    var $joinrule;                        // text(-1)  not_null default_open

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('Community',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE
    
	/**
	 * 󥹥ȥ饯
	 * @author halt <halt@sonata.zive.net>
	 */
	function Community()
	{
		$this->keys('id');
	}
	
    /*
	 * set keyword for find()
	 */
    function setKeyword($str) {

        $keywords = preg_split("/(\s|)+/",$this->escape(strtolower($str)));

        foreach($keywords as $keyword) {
            $this->whereAdd(sprintf("(lower(name) like '%%%s%%' OR lower(explanation) like '%%%s%%')",$keyword,$keyword),'AND');
        }

    }

    /**
	 * Checks if a account joined at this community
	 */
    function isMember( $account = null ) {

        if( $account == null ) {
            $my = getMe();
            $account = $my->account;
        }

        $community_member = new Community_member();
        $community_member->community = $this->id;
        $community_member->member = $account;

        if( $community_member->find() > 0 ) {
			return true;
		}

        return false;

    }
	
	/**
	 * ߥ˥ƥΰ֤
	 * @author halt <halt@sonata.zive.net>
	 */
	function getCommunityList($start,$num_count)
	{

		$start = intval($start);
		$num_count = intval($num_count);
		
		$this->limit($start,$num_count);
		$this->find();
		
		$inc = 0;
		$rows = array();
		while( ($inc < $num_count) && ($this->fetch()) ){

			$rows[$inc] = $this->toArray();
			$inc++;

		}
		
		return $rows;		
	}
	
	/**
	 * ߥ˥ƥο֤
	 * @author halt <halt@sonata.zive.net>
	 * @todo halt:DataObjectǤȤϤ
	 */
	function getTotalCount()
	{
		$db =& $this->getDataBaseConnection();
		
		$query = "SELECT count(*) FROM {$this->__table}";
		
		return $db->getOne($query);
	}
}
?>